﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace arithmeclick
{
    public partial class Form1 : Form
    {
        Button[] operator_buttons = new Button[15];
        operation[] operations = new operation[15];
        int[] moves = new int[15];
        button_detail[] button_details = new button_detail[15];
        int current_int;
        int target_int;
        int current_focus;
        int button_reshufflings;
        public Form1()
        {
            InitializeComponent();
        }

        private void init_game()
        {
            Random r = new Random();
            int digits = r.Next(3, 6);
            int min_val = 1;
            for (int i = 0; i < digits; i++)
            {
                min_val *= 10;
            }
            target_int = r.Next(min_val/10,min_val-1);
            digits = r.Next(3, 6);
            min_val = 1;
            for (int i = 0; i < digits; i++)
            {
                min_val *= 10;
            }
            current_int = r.Next(min_val / 10, min_val - 1);
            current_focus = r.Next(0, 15);
        }

        private string movement_string(int movement)
        {
            if (movement == 0)
                return "stay";
            else if (movement < 0)
                return "left " + movement.ToString();
            else
                return "right " + movement.ToString();
        }

        private void display_correctly()
        {
            for (int i = 0; i < 15; i++)
            {
                int actual_button_id = (i + 15 + 7 - current_focus) % 15;
                operator_buttons[i].Text = button_details[actual_button_id].op.symbol.ToString() + ' '.ToString() + button_details[actual_button_id].op.value.ToString() + '\n'.ToString() + this.movement_string(-button_details[actual_button_id].movement);
                if (i == 6 || i == 7 || i == 8)
                    operator_buttons[i].Enabled = true;
                else
                    operator_buttons[i].Enabled = false;
            }
            target_label.Text = "Target: " + target_int.ToString();
            current_label.Text = "Current: " + current_int.ToString();
        }

        private void init_buttons(bool re_pair)
        {
            button_reshufflings++;
            //button_detail[] button_details_ordered = new button_detail[15];
            Random r=new Random();
            if (re_pair)
            {
                for (int i = 0; i < 15; i++)
                {
                    button_details[i] = new button_detail(operations[i], moves[i]);
                }
                for (int i = 0; i < 15; i++)
                {
                    int swap_id = r.Next(i, 15);
                    int move_swap = button_details[swap_id].movement;
                    button_details[swap_id].movement = button_details[i].movement;
                    button_details[i].movement = move_swap;
                }
            }
            for (int i = 0; i < 15; i++)
            {
                int swap_id = r.Next(i, 15);
                button_detail swap = button_details[swap_id];
                button_details[swap_id] = button_details[i];
                button_details[i] = swap;
            }

        }
        private bool all_buttons_clickable(List<int> accessible_positons)
        {
            for (int i = 0; i < 15; i++)
            {
                if (!accessible_positons.Contains((i + 14) % 15) && !accessible_positons.Contains(i) && !accessible_positons.Contains((i + 1) % 15))
                    return false;
            }
            return true;

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            operator_buttons[0] = button1;
            operator_buttons[1] = button2;
            operator_buttons[2] = button3;
            operator_buttons[3] = button4;
            operator_buttons[4] = button5;
            operator_buttons[5] = button6;
            operator_buttons[6] = button7;
            operator_buttons[7] = button8;
            operator_buttons[8] = button9;
            operator_buttons[9] = button10;
            operator_buttons[10] = button11;
            operator_buttons[11] = button12;
            operator_buttons[12] = button13;
            operator_buttons[13] = button14;
            operator_buttons[14] = button15;
            operations[0] = new operation('=', 0);
            operations[1] = new operation('+', 1);
            operations[2] = new operation('+', 10);
            operations[3] = new operation('+', 100);
            operations[4] = new operation('+', 1000);
            operations[5] = new operation('-', 1);
            operations[6] = new operation('-', 5);
            operations[7] = new operation('-', 50);
            operations[8] = new operation('-', 500);
            operations[9] = new operation('*', 2);
            operations[10] = new operation('*', 5);
            operations[11] = new operation('*', 10);
            operations[12] = new operation('/', 2);
            operations[13] = new operation('/', 10);
            operations[14] = new operation('^', 2);

            for (int i = -7; i < 8; i++)
            {
                moves[i + 7] = i;
            }
            reshuffle_all();

            init_game();

            display_correctly();
        }
        private void reshuffle_all()
        {
            button_reshufflings = 0;
            reshuffle_ops();
            reshuffle_accessibility();
            reshufflings_label.Text = "Arrangements tried: " + button_reshufflings.ToString();
        }
        private void reshuffle_ops()
        {
            init_buttons(true);
            bool stopiter = false;
            while (!stopiter)
            {
                for (int i = 0; i < 15; i++)
                {
                    if (button_details[i].movement == 0)
                    {
                        if (button_details[i].op.value != 0)
                        {
                            init_buttons(true);
                            break;
                        }
                        else
                        {
                            stopiter = true;
                        }
                    }
                }
            }
        }
        private void reshuffle_accessibility()
        {

            bool acceptable_configuration_reached = true; //all buttons clickable from any start point
            while(!acceptable_configuration_reached)
            {
                bool current_start_point_acceptable = false; // all buttons clickable from current start point
                for (int k = 0; k < 15; k++)
                {
                    if (button_details[k].movement == 0) continue;
                    List<int> accessible = new List<int>();
                    accessible.Add(k);
                    List<int> boundary = new List<int>();
                    boundary.Add(k);
                    List<int> new_found = new List<int>();
                    bool not_all_checked = true;
                    while (not_all_checked)
                    {
                        foreach (int i in boundary)
                        {
                            int[] t = new int[3];
                            t[0] = (i + 15 + button_details[(i + 14) % 15].movement) % 15;
                            t[1] = (i + 15 + button_details[i].movement) % 15;
                            t[2] = (i + 15 + button_details[(i + 1) % 15].movement) % 15;
                            not_all_checked = false;
                            for (int j = 0; j < 3; j++)
                            {
                                if (!accessible.Contains(t[j]) && !new_found.Contains(t[j]))
                                {
                                    not_all_checked = true;
                                    new_found.Add(t[j]);
                                }
                            }
                        }
                        accessible.AddRange(new_found);
                        boundary.RemoveRange(0, boundary.Count);
                        boundary.AddRange(new_found);
                        new_found.RemoveRange(0, new_found.Count);
                        //if (accessible.Count == 15) break;
                        current_start_point_acceptable = (all_buttons_clickable(accessible));
                        if (current_start_point_acceptable) break;
                    }
                    acceptable_configuration_reached = acceptable_configuration_reached && current_start_point_acceptable;
                    if (!acceptable_configuration_reached)
                    {
                        init_buttons(false);
                    }
                }
                if (!acceptable_configuration_reached)
                {
                    init_buttons(false);
                }
            }
        }
        private void do_click(int id)
        {
            button_detail b = button_details[(id + 30 + 7 - current_focus) % 15];
            current_focus = (current_focus + 15+b.movement)%15;
            switch (b.op.symbol)
            {
                case '=':
                    if (current_int == target_int)
                        System.Windows.Forms.MessageBox.Show("You win!");
                    else
                        System.Windows.Forms.MessageBox.Show("You lose!");
                    init_game();
                    break;
                case '+':
                    current_int += b.op.value;
                    break;
                case '-':
                    current_int -= b.op.value;
                    break;
                case '*':
                    current_int *= b.op.value;
                    break;
                case '/':
                    current_int /= b.op.value;
                    break;
                case '^':
                    {
                        current_int = current_int * current_int;
                    }
                    break;

            }
            display_correctly();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            do_click(0);
        }


        private void button2_Click_1(object sender, EventArgs e)
        {
            do_click(1);
        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            do_click(2);
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            do_click(3);
        }

        private void button5_Click_1(object sender, EventArgs e)
        {
            do_click(4);
        }

        private void button6_Click_1(object sender, EventArgs e)
        {
            do_click(5);
        }

        private void button7_Click_1(object sender, EventArgs e)
        {
            do_click(6);
        }

        private void button8_Click_1(object sender, EventArgs e)
        {
            do_click(7);
        }

        private void button9_Click_1(object sender, EventArgs e)
        {
            do_click(8);
        }

        private void button10_Click_1(object sender, EventArgs e)
        {
            do_click(9);
        }

        private void button11_Click_1(object sender, EventArgs e)
        {
            do_click(10);
        }

        private void button12_Click_1(object sender, EventArgs e)
        {
            do_click(11);
        }

        private void button13_Click_1(object sender, EventArgs e)
        {
            do_click(12);
        }

        private void button14_Click_1(object sender, EventArgs e)
        {
            do_click(13);
        }

        private void button15_Click_1(object sender, EventArgs e)
        {
            do_click(14);
        }

        private void restart_button_Click(object sender, EventArgs e)
        {
            init_game();
            display_correctly();
        }

        private void reshuffle_button_Click(object sender, EventArgs e)
        {
            reshuffle_all();
            init_game();
            display_correctly();
        }
    }
}


class operation { public char symbol; public int value;
public operation(char ss, int vv)
{
    this.symbol = ss;
    this.value = vv;
}
};
class button_detail { public operation op; public int movement;
public button_detail(operation oo, int mm)
{
    this.op = oo;
    this.movement = mm;
}
};